unit UHashStr;
          (*  TStrHashList par Montor*)
interface

type
    PPTreeItem =^PTreeItem;
    PTreeItem  =^TTreeItem;
    TTreeItem = record
         Value :integer;
         Key :string;
         Childs :array[0..1]of PTreeItem;
         Next : PTreeItem;
    end;

    TStrHashList = class
    private
       FTree  : PTreeItem;
       FList  : PTreeItem;
       function FindNode(const Key :string):PPTreeItem;
       function HashOf(const AKey:string): Cardinal;
   public
       destructor Destroy();override;
       function ValueOf(const AKey:string):integer;
       procedure Add(const AKey:string;AData:integer);
   end;

implementation

{ TStrHashList }

procedure TStrHashList.Add(const AKey:string; AData: integer);
var
 V: PPTreeItem;
 P: PTreeItem;
begin
    V :=FindNode(AKey);
    if V^ <> nil then
       Exit;
    New(P);
    with P^ do
    begin
        Key := AKey;
        Value := AData;
        Next  := FList;
        Childs[0]  := nil;
        Childs[1]  := nil;
    end;
    V^:=P;
    FList := P;
end;

destructor TStrHashList.Destroy;
var
  P, N: PTreeItem;
begin
        P := FList;
        while P <> nil do
        begin
          N := P^.Next;
          Dispose(P);
          P := N;
        end;
    inherited;
end;

function TStrHashList.FindNode(const Key :string): PPTreeItem;
var
 N:Cardinal;
begin
    N:=HashOf(Key);
    Result:=@FTree;
    repeat

      if (Result^ = nil)then
         break
      else if  (Result^.Key = Key)then
         break
      else
         Result :=@Result^.Childs[N and 1];

      N := ((N shl 1) or (N shr(SizeOf(N) * 8 - 1)));
    until False;
end;

function TStrHashList.HashOf(const AKey:string): Cardinal;
var
  I:integer;
begin
  Result := 0;
  for I := 1 to Length(AKey) do
    Result := (Result shl 3) xor Result xor Ord(AKey[I]);
end;

function TStrHashList.ValueOf(const AKey: string): integer;
var
 V: PPTreeItem;
begin
    V :=FindNode(AKey);
    if V^ <> nil then
      Result := V^.Value
    else
      Result := -1;
end;

end.
